// Olendi liigutamiseks/joonistamiseks meldu


#include <allegro.h>
#include "olend.h"

void astu (olend* astuja, fixed pikslit)
{
  fixed offset_x;
  fixed offset_y;
  astuja->vanax = astuja->x;
  astuja->vanay = astuja->y;
  offset_x = fsin (astuja->angle);
  offset_y = fcos (astuja->angle);
  astuja->x += fmul (offset_x, pikslit);
  astuja->y -= fmul (offset_y, pikslit);
}

void p66ra (olend* p66raja, fixed kraadi)
{
  p66raja->vanaangle = p66raja->angle;
  p66raja->angle += kraadi;
  if (p66raja->angle <= 0)
    p66raja->angle = ftofix(255);
  else if (p66raja->angle >= ftofix(255))
    p66raja->angle = 0;
}

void joonista (olend* objekt)
{
  if (objekt->vanax != objekt->x || objekt->vanay != objekt->y || objekt->vanaangle != objekt->angle) {
    rectfill (screen, fixtoi(objekt->vanax), fixtoi(objekt->vanay), fixtoi(objekt->vanax)+40, fixtoi(objekt->vanay)+40, makecol (0,0,0));
    rotate_sprite (screen, objekt->pilt, fixtoi(objekt->x), fixtoi(objekt->y), objekt->angle);
    objekt->vanaangle = objekt->angle;
    objekt->vanax = objekt->x;
    objekt->vanay = objekt->y;
  }
}
