// Tegelik "AI" :)


#include <math.h>
#include <allegro.h>
#include "olend.h"
#include "pahalane.h"

void pahalane_uuenda (olend* pahalane, olend* jalitatav)
{
  // Kui jalitatav on 90 kraadise silmaringi sees, p66ra tema
  // poole. Kui ta on 3 kraadi sees, siis mine tema suunas.

  fixed vahex, vahey, vahenurk, lisanurk, vahenurk2;

  vahex = pahalane->x - jalitatav->x;
  vahey = pahalane->y - jalitatav->y;
  vahenurk = fatan (fdiv (vahey, vahex));

  if (vahex >= 0 && vahey >= 0) {
    lisanurk = itofix (192);
  }
  if (vahex < 0 && vahey >= 0) {
    lisanurk = itofix (64);
  }
  if (vahex > 0 && vahey < 0) {
    lisanurk = itofix (192);
  }
  if (vahex < 0 && vahey < 0) {
    lisanurk = itofix (64);
  }

  vahenurk2 = lisanurk + vahenurk - pahalane->angle;

                               // __ Silmaring
  if (fabs (fixtof (vahenurk2)) < 32 || fabs (fixtof (vahenurk2)) > 128) {
    pahalane->angle = lisanurk + vahenurk;
                                 // _ Jalitamine
    if (fabs (fixtof (vahenurk2)) < 1)
      astu (pahalane, ftofix (0.02));
  }

}
